//reads only files with numerical attributes

class DataReader
{
    private float X[][];
    private int labels[];
    private String textlines[];
    private String token;
    private int labelLocation;
    
    DataReader( String fileName, String token, int labelLocation )
    {
      textlines = loadStrings(fileName);
      this.token = token;
      this.labelLocation = labelLocation;
      
      X = new float[textlines.length][]; 
      labels = new int[textlines.length];
      
      int n=0;
      int k=0;
      for( int i = 0; i < textlines.length; i++ )
      {
         String[] currentline = split(textlines[i], token);
         if(labelLocation == -1 )
           n = currentline.length;
         else
           n = currentline.length-1;
          
         X[i] = new float[n];  
         k = 0;
         for (int j = 0; j < currentline.length; j++)
         {
            if(j == labelLocation )
                labels[i] =  (int)Float.valueOf(currentline[j]).floatValue();
            else
                X[i][k++] =  Float.valueOf(currentline[j]).floatValue();
         }
        
      }
    }    
    
    float[][] getData(){ return this.X;}; 
    int[]     getLabels() { return this.labels; };
}
