class Graph
{
  private ArrayList<Node> N;
  private ArrayList<Edge> E;//arestas

  Graph()
  {  
      this.N = new ArrayList<Node>();
      this.E = new ArrayList<Edge>();
  }
  
  //retorna o nó, recebendo como parâmetro o ID
  public Node getNode(int id)
  {
        for(int i = 0; i < N.size(); i++)
            if( N.get(i).getId() == id )
                return N.get(i);
         
        return null;
  }
  
  public void addNode(Node n)
  {
      N.add(n);
  }
  
  public void addEdge(Node from, Node to, float w, int id)
  {
      from.addEdge(new Edge(w, id, from, to));
      to.addEdge(new Edge(w, id, to, from));
      
      E.add(new Edge(w, id, from, to));
  }
  
  public int getNodeSize(){ return N.size();}
  public int getEdgeSize(){ return E.size(); }
  public Edge getEdge(int i){ return E.get(i);}
  
  public Edge getEdge(Node u, Node v)
  { 
      Edge e;
      for( int i = 0; i < E.size(); i++ )
      {
          e = E.get(i);
          
          if( e.getNodeFrom().getId() == u.getId() 
           && e.getNodeTo().getId() == v.getId())
             return e;
          
          if( e.getNodeFrom().getId() == v.getId() 
           && e.getNodeTo().getId() == u.getId())
             return e;
      }
      
      return null;
  }
  
  public boolean isConnected( Node u, Node v )
  {
      Edge e;
      for( int i = 0; i < E.size(); i++ )
      {
          e = E.get(i);
          
          if( e.getNodeFrom().getId() == u.getId() 
           && e.getNodeTo().getId() == v.getId())
             return true;
          
          if( e.getNodeFrom().getId() == v.getId() 
           && e.getNodeTo().getId() == u.getId())
             return true;
      }
      
      return false;
  }  
  
  public void show()
  {
      for( int i = 0; i < N.size(); i++)
      {
          println("\nNode ("+N.get(i).getId()+ ", "+N.get(i).getPosX()+ ", "+N.get(i).getPosY()+")");
          ArrayList<Edge> E = N.get(i).getEdges();
          print("   ");
          for(int j=0; j < E.size(); j++)
          {
              print(E.get(j).getNodeTo().getId()+"  ");
          }  
      }
  
  }
}
