class Node
  {
    private int   id;//identificador do nó
    private float pos[];//posicoes x e y
    private ArrayList<Edge> E;//arestas ligadas ao nó
    private int   ie;//contador de arestas
    
    private float disp[];//vetor atualizacao do force directed
    
    Node(int id, float x, float y)
    {
      
        E = new ArrayList<Edge>();
        this.id = id;
        pos = new float[2];
        pos[0] = x;
        pos[1] = y;
        
        disp = new float[2];
        disp[0] = 0;
        disp[1] = 0;
                
        this.ie = 0;
    }
    
    //getters
    public int getId() {return this.id;}//retorna o Id
    public float getPosX() {return this.pos[0];}//retorna posicao x
    public float getPosY() {return this.pos[1];}//retorna posicao y
    public float[] getPosXY() {return this.pos;}//retorna vetor de posicao x e y
    
    public float getDispX() {return this.disp[0];}//retorna posicao x
    public float getDispY() {return this.disp[1];}//retorna posicao y
    
    public int degree()
    {
        return getNeighbors().length;
    }
    
    //setters
    public void setId(int id){this.id = id;}
    public void setPosX(float x){this.pos[0] = x;}
    public void setPosY(float y){this.pos[1] = y;}
    public void setPosXY(float x, float y)
    {
        this.pos[0] = x;
        this.pos[1] = y;
    }
    
    public void setDispX(float x){this.disp[0] = x;}
    public void setDispY(float y){this.disp[1] = y;}
    public void setDispXY(float x, float y)
    {
        this.disp[0] = x;
        this.disp[1] = y;
    }
    
    public void addEdge(Edge e){this.E.add(e);}
    
    public Node[] getNeighbors()
    {
        Node neig[] = new Node[E.size()];
        
        for(int i = 0; i < neig.length; i++)
            neig[i] = E.get(i).getNodeTo();
        
        return neig;
    }
    
    public ArrayList<Edge> getEdges()
    {
       return E;
    }
  }  
